# -*- coding: utf8 -*-
# author: Ludwig Reiter

from sqlalchemy import event
from euhu.programs.qe import validate
from efa.model.participant import Participant, \
    generate_determine_reportable_function, listener_adapter
from ringo_bmasreport.reports.durchfuehrungsbericht import (
    indicators, recipe
)


program = "qe"


indicators['RI'].append(('C1.1', u'Teilnehmer/-innen, die erfolgreich eine Qualifizierung zur/m staatlich anerkannten Erzieher/-in abgeschlossen haben (C1.1)'))


def derive_indicators(values):
    """Perform validation and extract the indicators from that result."""
    result = validate(values)
    return result.eu_indicators.esf


td_update_listener = listener_adapter(
    generate_determine_reportable_function(derive_indicators,
                                           recipe,
                                           validate,
                                           program))

event.listen(Participant, 'after_update', td_update_listener)
